
package vt.cs.db.rmidb;

import java.rmi.*;
import java.util.*;
import vt.cs.db.*;

public class LocalTable extends Table {
	public RemoteTable 	table	= null;

	public LocalTable(RemoteTable table) {
		this.table = table;
	}

	/* ----------- Override all of the AttributeObject methods ---------- */
	public void setName(String name) {
		try {
			table.setName(name);
		}
		catch (Exception e) {
			e.printStackTrace();
		}
	}

	public String getName() {
		String	n = null;
		try {
			n = table.getName();
		}
		catch (Exception e) {
			e.printStackTrace();
		}
		return n;
	}

	public void setAttribute(String key, String value) {
		try {
			table.setAttribute(key, value);
		}
		catch (Exception e) {
			e.printStackTrace();
		}
	}

	public String getAttribute(String key) {
		String	n = null;
		try {
			n = (String) table.getAttribute(key);
		}
		catch (Exception e) {
			e.printStackTrace();
		}
		return n;
	}

	public String remoteAttribute(String key) {
		String	n = null;
		try {
			n = table.removeAttribute(key);
		}
		catch (Exception e) {
			e.printStackTrace();
		}
		return n;
	}

	public Enumeration attributeKeys() {
		Enumeration keys = null;
		try {
			keys = table.attributeKeys().elements();
		}
		catch (Exception e) {
			e.printStackTrace();
		}
		return keys;
	}
	/* ------------------------------------------------------------------ */

	/* ---------------- Override all of the Table methods ---------------- */
	public long rowcount() {
		long count = 0;
		try {
			count = table.rowcount();
		}
		catch (Exception e) {
			e.printStackTrace();
		}
		return count;
	}

	public Enumeration columnNames() {
		Enumeration names = null;
		try {
			names = table.columnNames().elements();
		}
		catch (Exception e) {
			e.printStackTrace();
		}
		return names;
	}

	public Enumeration columnNames(String type) {
		Enumeration names = null;
		try {
			names = table.columnNames(type).elements();
		}
		catch (Exception e) {
			e.printStackTrace();
		}
		return names;
	}

	public String description(String columnName) {
		String	desc = null;
		try {
			desc = table.description(columnName);
		}
		catch (Exception e) {
			e.printStackTrace();
		}
		return desc;
	}

	public Object get(int rowNumber, int columnNumber) {
		Object	obj	= null;
		try {
			obj = table.get(rowNumber, columnNumber);
		}
		catch (Exception e) {
			e.printStackTrace();
		}
		return obj;
	}

	public Object get(int rowNumber, String columnName) {
		Object	obj	= null;
		try {
			obj = table.get(rowNumber, columnName);
		}
		catch (Exception e) {
			e.printStackTrace();
		}
		return obj;
	}

	public Vector getColumn(String columnName) {
		Vector vec = null;
		try {
			vec = table.getColumn(columnName);
		}
		catch (Exception e) {
			e.printStackTrace();
		}
		return vec;
	}

	public Vector getColumn(int columnNumber) {
		Vector vec = null;
		try {
			vec = table.getColumn(columnNumber);
		}
		catch (Exception e) {
			e.printStackTrace();
		}
		return vec;
	}

	public void appendRow(Object[] rowData) {
		try {
			table.appendRow(rowData);
		}
		catch (Exception e) {
			e.printStackTrace();
		}
	}

	/* ------------------------------------------------------------------ */
}

