/*
 *
 * Written By:   Philip Isenhour
 * Date:         9 November 1996
 * Description:  Login view for RoomApplet
 *
 * $Header: /home/nie/cvsroot/prototype/vt/cs/virtSchool/client/LoginView.java,v 1.4 1997/02/19 19:43:34 begolej Exp $
 *
 * Copyright (c) 1996 Philip Isenhour
 * Copyright (c) 1996 Virginia Polytechnic University and State University
 */

package vt.cs.virtSchool.client;

import netscape.application.*;
import netscape.util.*;
import vt.cs.virtSchool.server.*;


/**
 * The <CODE>LoginView</CODE> class implements a very simple login screen,
 * with a text field for entering a username and a button to press to
 * log in.
 *
 * @version $Id: LoginView.java,v 1.4 1997/02/19 19:43:34 begolej Exp $
 */
public class LoginView extends View implements TextFieldOwner, Target {
  public TextField textField = null;
  private Button button	= null;
  private RoomApplet applet = null;

  public LoginView(int x, int y, int w, int h, RoomApplet applet) {
    super(x, y, w, h);

    this.applet = applet;

    textField = new TextField(0, 5, w, h/2 - 30);
    //textField.setFont(Font.fontNamed("Courier", 14, Font.BOLD));
    textField.setOwner(this);
    addSubview(textField);

    //button = Button.createPushButton(5, h/2 - 5, w - 10, h/2 - 20);
    button = Button.createPushButton(5, h/2 - 5, w - 10, h/2 - 20);
    button.setTarget(this);
    button.setCommand("buttonClick");
    //button.setFont(Font.fontNamed("Courier", 14, Font.BOLD));
    button.setTitle("Log in");
    addSubview(button);

    textField.setFocusedView();

    draw();
    debug("LoginView");
    textField.setFocusedView();
  }

  /* TextFieldOwner methods */
  public void textEditingDidBegin(TextField field) {
    debug("textEditingDidBegin:");
  }

  public void textEditingDidEnd(TextField field, int endCondition, 
				boolean contentsChanged) {
    debug("textEditingDidEnd: endConition="+endCondition);
    if ((endCondition == TextFieldOwner.TAB_KEY) ||
	(endCondition == TextFieldOwner.RETURN_KEY))
      button.click();
  }

  public boolean textEditingWillEnd(TextField field, int endCondition, 
				    boolean contentsChanged) {
    debug("textEditingWillEnd: endConition="+endCondition);
    return true;
  }

  public void textWasModified(TextField field) {
  }


  /* Target methods */
  public void performCommand(String command, Object object) {
    debug("performCommand: "+command);
    if (command.equals("buttonClick")) {
      debug("performCommand, checking textfield length");
      if (textField.stringValue().length() > 0) {
	removeFromSuperview();
	applet.login(textField.stringValue());
      }
    textField.setFocusedView();
   }
  }

  private static final boolean debug = false;
  private void debug(String message) {
    if (debug)
      System.out.println(getClass().getName()+": "+message);
  }

}

