package vt.cs.virtSchool.labapplets.Graph;

import java.awt.*;
import java.applet.*;

public class MPanel extends Panel {
  
  G2Dint graph = null;
  Graph gApplet;

  Button rangeBtn;
  Button fitBtn;
  Button redrawBtn;
  Button newDataBtn;
  Button selectBtn;
  Button coordBtn;

  Font font = new Font("TimesRoman", Font.BOLD, 16);

  public MPanel(Graph gc) {
    super();
    gApplet = gc;
    setFont(font);
    setLayout(new GridLayout(2, 3));

    setBackground(gApplet.getBackground());
    setForeground(Color.white);

    rangeBtn = new Button("Range");
    rangeBtn.setBackground(Color.blue);
    add(rangeBtn);

    fitBtn = new Button("Refit");
    fitBtn.setBackground(Color.blue);
    add(fitBtn);

    redrawBtn = new Button("Redraw");
    redrawBtn.setBackground(Color.blue);
    add(redrawBtn);

    newDataBtn = new Button("New");
    newDataBtn.setBackground(Color.blue);
    add(newDataBtn);

    selectBtn = new Button("Select");
    selectBtn.setBackground(Color.blue);
    add(selectBtn);

    coordBtn = new Button("Coord");
    coordBtn.setBackground(Color.blue);
    add(coordBtn);

  }

  /*****
  ** Reference must set so that the buttons will affect the 
  ** appropriate graph.
  *****/
  public void setGraph(G2Dint gr){
    graph = gr;
  }

  public void enableButtons(){
    if(rangeBtn.isEnabled() != true){
      rangeBtn.enable();
    }
    if(fitBtn.isEnabled() != true){
      fitBtn.enable();
    }
    if(redrawBtn.isEnabled() != true){
      redrawBtn.enable();
    }
    if(newDataBtn.isEnabled() != true){
      newDataBtn.enable();
    }
    if(selectBtn.isEnabled() != true){
      selectBtn.enable();
    }
    if(coordBtn.isEnabled() != true){
      coordBtn.enable();
    }
  }

  public void disableButtons(){
    if(rangeBtn.isEnabled() == true){
      rangeBtn.disable();
    }
    if(fitBtn.isEnabled() == true){
      fitBtn.disable();
    }
    if(redrawBtn.isEnabled() == true){
      redrawBtn.disable();
    }
    if(selectBtn.isEnabled() == true){
      selectBtn.disable();
    }
    if(coordBtn.isEnabled() == true){
      coordBtn.disable();
    }
  }

  public boolean action(Event evt, Object arg) {
    if(graph != null){
      if (evt.target instanceof Button) {
	if ((String)arg == "Range") {
	  //System.out.println("Range Button");
	  graph.keyDown(evt, (int)'m');
	}
	else if ((String)arg == "Refit"){
	  //System.out.println("Refit Data Button");
	  graph.keyDown(evt, (int)'R');
	}
	else if((String)arg == "Redraw") {
	  //System.out.println("Redraw Graph Button");
	  graph.keyDown(evt, (int)'r');
	}
	else if((String)arg == "New") {
	  //System.out.println("New Data Button");
	  if((graph.cpgin != null) && graph.cpgin.isVisible()){
	    graph.keyDown(evt, (int)'c'); //hide it
	    coordBtn.setLabel("Coord");
	  }
	  gApplet.newSelect();
	}
	else if((String)arg == "Select"){
	  if((graph.cpgin != null) && graph.cpgin.isVisible()){
	    graph.keyDown(evt, (int)'c'); //hide it
	    coordBtn.setLabel("Coord");
	  }	  
	  gApplet.showSelect();
	}
	else if((String)arg == "Coord"){
	  graph.keyDown(evt, (int)'c');
	  coordBtn.setLabel("Hide Coord");
	}
	else if((String)arg == "Hide Coord"){
	  graph.keyDown(evt, (int)'c');
	  coordBtn.setLabel("Coord");
	}	
	return true;
      }
    }
    else if(graph == null){
      if(evt.target instanceof Button){
	if((String)arg == "New"){
	  gApplet.newSelect();
	}
      }
      return true;
    }
    return false;
  }
}
    
    
    
