/*
 *
 * Written By:	James Begole
 * Date:			2 April 1996
 * Description:	Histogram Charting Tool
 *
 */

 
/*
 * $Header: /home/nie/cvsroot/prototype/vt/cs/virtSchool/labapplets/Histogram/OldHistogram.java,v 1.2 1997/01/06 17:39:46 isenhour Exp $
 *
 * Copyright (c) 1996 James "Bo" Begole
 * Copyright (c) 1996 Virginia Polytechnic University and State University
 */

/* this is a test comment */

package vt.cs.virtSchool.labapplets.Histogram;

import vt.cs.virtSchool.util.*;
import vt.cs.virtSchool.objectManager.ObjectManager;
//import vt.cs.ro.util.RemoteObject;

import java.rmi.Remote;
import java.rmi.NotBoundException;
import java.rmi.RemoteException;
import java.rmi.Naming;

import java.applet.*;
import java.awt.*;
import java.net.*;
import java.util.*;

public class OldHistogram extends Applet implements Runnable {
  private final boolean debug = false;
  private Thread life = null;

  protected HistoChart chart = null;
  private ObjectManager objectManager = null;
  private DataSets dataSets = null;

  public void init () {

    // Get parameters
    objectManager = RemoteObject.getObjectManager(this);
    dataSets = RemoteObject.getDataSets(this, objectManager);

    chart = new HistoChart(dataSets);
    setLayout(new BorderLayout());
    add("Center", chart);
  } 
	
  public void start() {
    if (life == null) {
      life = new Thread(this);
      life.start();
    }
  }	
		
  public void stop() {
    if (debug) System.out.println("stop: ");
    if (life != null) 
      life.stop();
    life = null;
  }
	
  public void run() {
    try {
      while (true){
	if (dataSets.newData())
	  chart.reBuild();
	if (debug) System.out.println("run:  ");
	try {
	  life.sleep(2000);
	} catch (InterruptedException e) {
	  System.out.println(e);
	}
      }
    } catch (RemoteException re) {
      if (debug) System.out.println("Histogram: run: "+re);
    }
  }
	

  public boolean handleEvent(Event e) {
    if (e.id == Event.WINDOW_DESTROY) {
      System.exit(0);
    }
    return false;
  }

  // Called when this is run as a stand-alone application	
  public static void main(String args[]) {
    Frame f = new Frame("Histogram");
    Histogram histo = new Histogram();

    histo.init();
    histo.start();

    f.add("Center", histo);
    f.resize(300, 300);
    f.show();
  }
}

