
//
//	DrawController.java
//
//	Copyright 1996,	Black Diamond Software.	 All rights reserved.
//
//	Written	by: Jason Beaver and Tyler Gingrich
//

package vt.cs.virtSchool.labapplets.WhiteBoard;

import netscape.application.*;
import netscape.util.*;

public class DrawController extends Object {
/*
	InternalWindow drawWindow;
*/
	ScrollGroup			scrollGroup			= null;
	SimpleDrawView 		drawView			= null;
	ToolController 		toolController		= null;;
	InspectorController inspectorController	= null;;

	public DrawController(ToolController aToolController,
		InspectorController anInspectorController, RootView root,
		String roomURL)	{
		super();

		// Hang	on to the tool controller and inspector	controller...
		toolController = aToolController;
		inspectorController = anInspectorController;

		// Set the inspector controller	now we're the
		// current draw	controller so we receive inspector changes...
		inspectorController.setCurrentDrawController(this);

/*
		// Create the draw window and contents...
		drawWindow = new InternalWindow(175,5,390,390);
		drawWindow.setRootView(root);

		Rect contentRect = drawWindow.contentView().bounds();
*/
		Rect contentRect = root.bounds();
		scrollGroup = new ScrollGroup(contentRect);
		scrollGroup.setHasHorizScrollBar(true);
		scrollGroup.setHasVertScrollBar(true);

		drawView = new SimpleDrawView(this,
			0,0,contentRect.width * 2 - scrollGroup.horizScrollBar().width(), 
			contentRect.height * 2 - scrollGroup.vertScrollBar().height(),
			roomURL);
		drawView.setBuffered(true);
		drawView.setHorizResizeInstruction(View.WIDTH_CAN_CHANGE);
		drawView.setVertResizeInstruction(View.HEIGHT_CAN_CHANGE);
//		drawView.setRootView(root);

		scrollGroup.setContentView(drawView);
		root.addSubview(scrollGroup);
/*
		drawWindow.contentView().addSubview(drawView);

		drawWindow.setType(Window.TITLE_TYPE);
		drawWindow.setResizable(true);
		drawWindow.setTitle("Prototype WhiteBoard");
		drawWindow.show();
*/
	}

	// Called when the user	changes	the stroke color in the	inspector...
	public void strokeColorChanged() {
		Vector selectedGraphics	= drawView.selectedGraphics();

		for (int i=0,count=selectedGraphics.count();i<count;i++) {
			Graphic	graphic	= ((Graphic)selectedGraphics.elementAt(i));

			graphic.setStrokeColor(inspectorController.strokeColor());
		}
		drawView.draw();
	}

	// Called when the user	changes	the fill color in the inspector...
	public void fillColorChanged() {
		Vector selectedGraphics	= drawView.selectedGraphics();

		for (int i=0,count=selectedGraphics.count();i<count;i++) {
			Graphic	graphic	= ((Graphic)selectedGraphics.elementAt(i));

			graphic.setFillColor(inspectorController.fillColor());
		}
		drawView.draw();
	}

	// Called when the user	changes	the filled state in the	inspector...
	public void filledStateChanged() {
		Vector selectedGraphics	= drawView.selectedGraphics();

		for (int i=0,count=selectedGraphics.count();i<count;i++) {
			Graphic	graphic	= ((Graphic)selectedGraphics.elementAt(i));

			graphic.setFilled(inspectorController.filledState());
		}
		drawView.draw();
	}

	// Called when the user	clicks the "Move to back" icon in the inspector...
	public void moveToBack() {
		Vector selectedGraphics	= drawView.selectedGraphics();
		Vector graphics	= drawView.graphics();

		for (int i=selectedGraphics.count()-1;i>=0;i--)	{
			Graphic	graphic	= ((Graphic)selectedGraphics.elementAt(i));

			graphics.removeElement(graphic);
			graphics.insertElementAt(graphic,0);
		}
		drawView.draw();
	}

	// Called when the user	clicks the "Bring to front" icon in the	inspector...
	public void moveToFront() {
		Vector selectedGraphics	= drawView.selectedGraphics();
		Vector graphics	= drawView.graphics();

		for (int i=0,count=selectedGraphics.count();i<count;i++) {
			Graphic	graphic	= ((Graphic)selectedGraphics.elementAt(i));

			graphics.removeElement(graphic);
			graphics.addElement(graphic);
		}
		drawView.draw();
	}

	// Called when something in the	draw view changes.  This keeps the inspector
	// in sync with	the currently selected graphic/graphics...
	public void updateInspector() {
		Vector selectedGraphics	= drawView.selectedGraphics();

		if (selectedGraphics.count() > 1) {
			inspectorController.setStrokeColor(Color.white);
			inspectorController.setFillColor(Color.white);
			inspectorController.setFilledState(false);
		} else if (selectedGraphics.count() == 1) {
			Graphic	graphic	= ((Graphic)selectedGraphics.elementAt(0));

			inspectorController.setStrokeColor(graphic.strokeColor());
			inspectorController.setFillColor(graphic.fillColor());
			inspectorController.setFilledState(graphic.isFilled());
		}
	}

	// Returns the name of the currently selected tool in the tool bar...
	public String selectedTool() {
		return toolController.selectedTool();
	}

	// Returns the current stroke color in the inspector...
	public Color currentStrokeColor() {
		return inspectorController.strokeColor();
	}

	// Returns the current fill color in the inspector...
	public Color currentFillColor()	{
		return inspectorController.fillColor();
	}

	// Returns the current filled state in the inspector...
	public boolean currentFilledState() {
		return inspectorController.filledState();
	}
}
