
//
//	Lasso.java
//
//	Copyright 1996, Black Diamond Software.  All rights reserved.
//
//	Written by: Jason Beaver and Tyler Gingrich
//

package vt.cs.virtSchool.labapplets.WhiteBoard;

import netscape.application.*;
import netscape.util.*;

public class Lasso extends Rectangle {

	public Lasso() {
		super();
	}

	// This is called repeatedly as the user manipulates the graphic...
	public void updateGraphic(MouseEvent event,SimpleDrawView view) {
		super.updateGraphic(event,view);

		// Make sure width and height are positive since
		// intersectsRect() requires it...
		Rect lassoRect = new Rect();
		lassoRect.x = (rect.width<0)?rect.x+rect.width:rect.x;
		lassoRect.y = (rect.height<0)?rect.y+rect.height:rect.y;
		lassoRect.width = Math.abs(rect.width);
		lassoRect.height = Math.abs(rect.height);

		// Unselect all graphics...
		view.unselectAllGraphics();

		// Select intersecting graphics...
		Vector graphics = view.graphics();
		for (int i=0,count=graphics.count();i<count;i++) {
			Graphic graphic = ((Graphic)graphics.elementAt(i));
			if (graphic.intersectsRect(lassoRect))
				view.selectGraphic(graphic);
		}
		view.draw();
	}

	// Lasso's are always light gray...
	public Color strokeColor() {
		return Color.lightGray;
	}

	// Lasso's are never filled...
	public boolean isFilled() {
		return false;
	}

	// Lasso's never have handles...
	public Vector handles() {
		return new Vector();
	}

	// Called when the user finishes lassoing graphics.
	// We need to remove ourself so we disappear...
	public void finishManipulation(MouseEvent event,SimpleDrawView view) {
//		view.setCurrentOperation(SimpleDrawView.NONE);
		super.finishManipulation(event,view);
		view.removeGraphic(this);
	}
}

