/*
 *
 * Written By:   James "Bo" Begole
 * Date:         1 July 1996
 * Description:  Remote Object Interface for Reaction Timer Data
 *
 * Usage Notes:
 *
 */
 
/*
 * $Header: /home/nie/cvsroot/prototype/vt/cs/virtSchool/util/DataSet.java,v 1.4 1996/09/18 20:07:53 isenhour Exp $
 *
 * Copyright (c) 1996 James "Bo" Begole
 * Copyright (c) 1996 Virginia Polytechnic University and State University
 */

package vt.cs.virtSchool.util;

import java.util.*;

/**
 * This interface may be replaced soon and should NOT be used directly
 * by producer or consumer applets. vt.cs.virtSchool.util.ConsumerStream
 * and vt.cs.virtSchool.util.ProducerStream should be used instead. See
 * vt.cs.virtSchool.labapplets.Collision and 
 * vt.cs.virtSchool.labapplets.Meter for examples.
 */
public interface DataSet extends java.rmi.Remote {

  // Producer Methods
  public void addPoint(long newPoint) throws java.rmi.RemoteException;

  public void put(String key, Object value) throws java.rmi.RemoteException;

  // Consumer Methods
  public Vector getPoints() throws java.rmi.RemoteException;	

  public boolean newData() throws java.rmi.RemoteException;

  public long maxValue() throws java.rmi.RemoteException;

  public long minValue() throws java.rmi.RemoteException;

  public Vector get(String key, String typeName) throws 
	java.rmi.RemoteException;

  public Vector get(String key) throws java.rmi.RemoteException;

  public Vector getKeys(String typeName) throws java.rmi.RemoteException;

}

