 
/*
 *
 * Written By:   James "Bo" Begole
 * Date:         31 May 1996
 * Description:  Modal Dialog for User Login to Virtual School
 *
 * Usage Notes:
 *
 * 
 */
 
/*
 * $Header: /home/nie/cvsroot/prototype/vt/cs/virtSchool/worldClient/LoginDialog.java,v 1.1.1.1 1996/09/17 05:23:16 isenhour Exp $
 * Modified for use by the NIE project.
 * Copyright (c) 1996 James "Bo" Begole, Craig Struble
 * Copyright (c) 1996 Virginia Polytechnic University and State University
 */

	/**	
	 * Displays a dialog that will let the user login in.
	 */
	 
 
package vt.cs.virtSchool.worldClient;

import java.awt.*;

import como.awt.*;
import como.sys.*;

public class LoginDialog extends Dialog {
	static int MIN_NAME_LENGTH = 1;
	UserPanel loginuserpanel;
	SmartFrame loginNameTooShort;
	SmartFrame loginClickMap;
	User ego;
	
	WorldClient worldClient;


	public LoginDialog(Frame parent, String title, WorldClient worldClient, Image map) {
		super(parent, title, true);
		this.worldClient = worldClient;
		
		setLayout(new BorderLayout());
		Panel p = new Panel();
		p.setLayout(new VertLayout(VertLayout.STRETCH));
		p.add(new Label("Please fill in the following information to log in:"));
		p.add(new Label("On the map, click at your current location"));
		add("North",p);
		ego = new User(0,"");
		ego.put(ego.COMMENT,"");
		ego.put(ego.LOCATION,new Integer(0)); // that way we will not set a default position
		loginuserpanel = new UserPanel(ego,"Click here to log in!",map);
		add("Center",loginuserpanel);

		ego = null;
		resize(640, 480);
	}
	
	public boolean action(Event evt, Object arg) {
		if (evt.target == loginuserpanel) {
			ego = loginuserpanel.getUser();

			if (ego.get(ego.LOCATION) instanceof Integer) {
				if ((loginClickMap == null) || (!loginClickMap.isVisible())) {
					loginClickMap = new SmartFrame("Please click on the map where you are from.");
					}
				return true;
				}
			if (ego.get(ego.NAME).toString().trim().length()  <= MIN_NAME_LENGTH) {
				if ((loginNameTooShort == null) || (!loginNameTooShort.isVisible())) {
					loginNameTooShort = new SmartFrame("Your name must be at least "+
								(MIN_NAME_LENGTH+1)+" characters long.");
					}
				return true;
				}
			ego.put(ego.COLOR, new Color(ego.hashCode()));
			removeAll();

			setLayout( new BorderLayout() );
			add( "North", new Label("Logging in, please wait...") );

			layout();
			paintAll(getGraphics());

			if (loginNameTooShort != null) {
				loginNameTooShort.dispose();
				loginNameTooShort = null;
			}
			if (loginClickMap != null) {
				loginClickMap.dispose();
				loginClickMap = null;
			}
			
			worldClient.loginUser(ego);
			hide();

			return true;
		}
		return false;
	}
} 
