/*
 * Written By:   James "Bo" Begole
 * Date:         5 June 1996
 * Description:  Dialog to browse places and users logged in to Virtual School
 */

/*
 * $Header: /home/nie/cvsroot/prototype/vt/cs/virtSchool/worldClient/SessionsDialog.java,v 1.1.1.1 1996/09/17 05:23:17 isenhour Exp $
 * Copyright (c) 1996 James "Bo" Begole, Craig Struble
 * Copyright (c) 1996 Virginia Polytechnic University and State University
 */
 
package vt.cs.virtSchool.worldClient;   //virtSchool.util;

import java.awt.*;
import java.util.*;

/** 
  A dialog window that allows a user to browse sessions specified by the prefix
  */

public class SessionsDialog extends Dialog {
  private String prefix;

  SessionAccessor sessionAccessor;
	
  SessionsPanel sessionsPanel;
  UsersPanel usersPanel;


  public SessionsDialog(Frame parent, String title, String prefix, SessionAccessor sessionAccessor) {
    super(parent, title, false);
    this.sessionAccessor = sessionAccessor;
    this.prefix = prefix;
		
    usersPanel = new UsersPanel(sessionAccessor, "People Logged In:", 10);
    sessionsPanel = new SessionsPanel(sessionAccessor, "Sessions:", prefix, usersPanel, 10);
		
    // Set up the dual lists Panel
    Panel listsPanel = new Panel();
    listsPanel.setLayout(null);
    listsPanel.add(sessionsPanel);
    listsPanel.add(usersPanel);
    sessionsPanel.reshape(0, 0, 325, 250);
    usersPanel.reshape(335, 0, 125, 250);
		
    // Set up the dialog Buttons Panel
    Panel dialogButtons = new Panel();
    dialogButtons.add(new Button("Close"));
		
    // Set up the dialog frame
    setLayout(null);
    add(listsPanel);
    add(dialogButtons);
    resize(500, 340);
    listsPanel.reshape(10, 50, 480, 250);
    dialogButtons.reshape(10, 300, 480, 30);		

    // fill the lists
    sessionsPanel.update();
  }
	
	
	
  public boolean handleEvent(Event e) {
    if ((e.id == Event.WINDOW_DESTROY)|| ("Close".equals(e.arg))) {
      hide();
    }
    return super.handleEvent(e);
  }
}

